
#ifndef __SETUP_BB_CPP_H__
#define __SETUP_BB_CPP_H__ 


Module *init_BB(int port){

	void arduino_in_written(const SharedVariableSubscriptionReport<std::string>& report);
	void arduino_out_written(const SharedVariableSubscriptionReport<std::string>& report);

        // Configure the module to run on port 2011
        Module *module = new Module(port);
        // Start the module logic
        module->start();

        // Setup shared variables
        module->setupSharedVariable<StringSharedVariable>("sensor", arduino_in);
        module->setupSharedVariable<StringSharedVariable>("actuator", arduino_out);
        //module.setupSharedVariable<StringSharedVariable>("test_shared_var", arduino_out);

        // Subscribe to the shared variable and the function that handle incomming data
        arduino_in->writeNotification.connect(arduino_in_written);
        arduino_out->writeNotification.connect(arduino_out_written);
        ((SharedVariable*)arduino_in)->subscribe(SharedVariableReportType::SendContent, SharedVariableSubscriptionType::WriteOthers);
        ((SharedVariable*)arduino_out)->subscribe(SharedVariableReportType::SendContent, SharedVariableSubscriptionType::WriteOthers);

	return module;
}



Module *init_BB_sensor_actuator(int port){

        void arduino_in_written(const SharedVariableSubscriptionReport<std::string>& report);
        void arduino_out_written(const SharedVariableSubscriptionReport<std::string>& report);

        // Configure the module to run on port 2011
        Module *module = new Module(port);
        // Start the module logic
        module->start();

        // Setup shared variables
        module->setupSharedVariable<StringSharedVariable>("sensor", arduino_in);
        module->setupSharedVariable<StringSharedVariable>("actuator", arduino_out);
        //module.setupSharedVariable<StringSharedVariable>("test_shared_var", arduino_out);

        // Subscribe to the shared variable and the function that handle incomming data
        //arduino_in->writeNotification.connect(arduino_in_written);
        arduino_out->writeNotification.connect(arduino_out_written);
        ((SharedVariable*)arduino_in)->subscribe(SharedVariableReportType::SendContent, SharedVariableSubscriptionType::WriteOthers);
        ((SharedVariable*)arduino_out)->subscribe(SharedVariableReportType::SendContent, SharedVariableSubscriptionType::WriteOthers);

        return module;
}



#endif
