import serial
import time
from pyrobotics import BB
from pyrobotics.messages import Response, Command


def cmd_one(c):
    time.sleep(1)
    return Response.FromCommandObject(c, True, 'cmd_one response')

def cmd_two(c):
    time.sleep(5)
    return Response.FromCommandObject(c, True, 'cmd_two response')


fmap = {
        'cmd_one' : cmd_one,
        'cmd_two' : (cmd_two, True)
        }


def ActuatorHandler(sv):
  print '[ACTUATOR] ',
  #print sv.varName
  #print sv.svType
  #if sv.size >= 0:
    #print sv.size
  print sv.data




def SensorHandler(sv):
  print '[SENSOR] ',
  #print sv.varName
  #print sv.svType
  #if sv.size >= 0:
    #print sv.size
  print sv.data




def Initialize():
    	BB.Initialize(2040, fmap)

    	BB.Start()

    	BB.CreateSharedVar(BB.SharedVarTypes.STRING, 'sensor')
    	BB.WriteSharedVar(BB.SharedVarTypes.STRING, 'sensor', 'initial_value')
    	BB.CreateSharedVar(BB.SharedVarTypes.STRING, 'actuator')
    	BB.WriteSharedVar(BB.SharedVarTypes.STRING, 'actuator', 'initial_value')
        BB.SubscribeToSharedVar('sensor',SensorHandler, subscriptionType='writeothers', reportType='content')
        BB.SubscribeToSharedVar('actuator',ActuatorHandler, subscriptionType='writeothers', reportType='content')

	
	BB.SetReady()


def main():

	Initialize()

	while True:
		s = raw_input("sv value: ")

		BB.WriteSharedVar(BB.SharedVarTypes.STRING, 'actuator', s)

if __name__ == "__main__":

    main()

